/*
 * The Apache Software License, Version 1.1
 *
 *
 * Copyright (c) 2002 The Apache Software Foundation.  All rights 
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:  
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "WSIF" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written 
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation and was
 * originally based on software copyright (c) 2001, 2002, International
 * Business Machines, Inc., http://www.apache.org.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 */

package org.apache.wsif.wsdl.extensions.format;

import javax.wsdl.extensions.ExtensibilityElement;
import javax.xml.namespace.QName;

/**
 * @author Ant Elder <antelder@apache.org>
 * @author Jeremy Hughes <hughesj@apache.org>
 */
public class TypeMapping
    implements java.io.Serializable, ExtensibilityElement {

	private static final long serialVersionUID = 1L;

    protected QName fieldElementType = FormatBindingConstants.Q_ELEM_FORMAT_BINDING;
    private String fieldEncoding;
    private String fieldStyle;
    protected java.util.List fieldTypeMaps = new java.util.Vector();

    /**
     * 
     */
    public TypeMapping() {
        super();
    }
    
    /**
     * Insert the method's description here.
     * Creation date: (6/19/2001 2:59:59 PM)
     * @param newPartTypes java.util.List
     */
    public void addMap(TypeMap typeMap) {
        fieldTypeMaps.add(typeMap);
    }
    
    /**
      * Get the type of this extensibility element.
      *
      * @return the extensibility element's type
      */
    public QName getElementType() {
        return this.fieldElementType;
    }
    
    /**
     * Insert the method's description here.
     * Creation date: (6/19/2001 1:23:29 PM)
     * @return java.lang.String
     */
    public java.lang.String getStyle() {
        return fieldStyle;
    }

    public java.lang.String getEncoding() {
        return fieldEncoding;
    }

    /**
     * Insert the method's description here.
     * Creation date: (6/19/2001 2:59:59 PM)
     * @return java.util.List
     */
    public java.util.List getMaps() {
        return fieldTypeMaps;
    }
    
    /**
      * Get whether or not the semantics of this extension
      * are required. Relates to the wsdl:required attribute.
      */
    public Boolean getRequired() {
        return null;
    }
    
    /**
      * Set the type of this extensibility element.
      *
      * @param elementType the type
      */
    public void setElementType(QName aElementType) {

        this.fieldElementType = aElementType;
    }
    
    /**
     * Insert the method's description here.
     * Creation date: (6/19/2001 1:23:29 PM)
     * @param newEncodingStyle java.lang.String
     */
    public void setStyle(java.lang.String newStyle) {
        fieldStyle = newStyle;
    }

    public void setEncoding(java.lang.String newEncoding) {
        fieldEncoding = newEncoding;
    }
    
    /**
      * Set whether or not the semantics of this extension
      * are required. Relates to the wsdl:required attribute.
      */
    public void setRequired(Boolean required) {
    }
}